/*
 * Copyright (c) 2025. Sergey S. Chernov - All Rights Reserved
 *
 *  You may use, distribute and modify this code under the
 * terms of the private license, which you must obtain from the author
 *
 * To obtain the license, contact the author: https://t.me/real_sergeych or email to
 * real dot sergeych at gmail.
 */

@file:Suppress("unused")
package org.komputing.khash.keccak.extensions

import org.komputing.khash.keccak.Keccak
import org.komputing.khash.keccak.KeccakParameter

/**
 * Computes the proper Keccak digest of [this] byte array based on the given [parameter]
 */
@Deprecated("will be removed, use Hash", ReplaceWith("Hash"))
fun ByteArray.digestKeccak(parameter: KeccakParameter): ByteArray {
    return Keccak.digest(this, parameter)
}

@Deprecated("will be removed, use Hash", ReplaceWith("Hash"))
fun UByteArray.digestKeccak(parameter: KeccakParameter): UByteArray {
    return Keccak.digest(this.asByteArray(), parameter).toUByteArray()
}

/**
 * Computes the proper Keccak digest of [this] string based on the given [parameter]
 */
@Deprecated("will be removed, use Hash", ReplaceWith("Hash"))
fun String.digestKeccak(parameter: KeccakParameter): ByteArray {
    return Keccak.digest(encodeToByteArray(), parameter)
}
